<?php
/*

  Featured_Products_Phoenix_v1.7.0
  Expiry Functions
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019: Rainer Schmied - @raiwa

  All rights reserved.﻿﻿

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

////
// Sets the status of a featured product
  function tep_set_featured_status($featured_id, $status) {
    return tep_db_query("update featured set status = '" . $status . "', date_status_change = now() where featured_id = '" . $featured_id . "'");
  }

////
// Auto expire featured products
  function tep_expire_featured() {
    $featured_query = tep_db_query("select featured_id from featured where status = '1' and now() >= expires_date and expires_date > 0");
    if (tep_db_num_rows($featured_query)) {
      while ($featured = tep_db_fetch_array($featured_query)) {
        tep_set_featured_status($featured['featured_id'], '0');
      }
    }
  }

////
// Function for version read out
  if(!function_exists('tep_version_readonly')) {
        function tep_version_readonly($value){
          $version_text = $value;
          return $version_text;
        }
  }

// Limit the size of text blocks to the nearest full word
//    $text is string to be truncated,
//    $maxchar is number of characters to limit to,
//    $wordlength is maximum length of a single word, to avoid long words breaking linewrap
  function tep_fp_featured_products_limit_text ($text, $maxchar, $wordlength = 40) {
    $text = str_replace ("\n", ' ', $text);
    $text = str_replace ("\r", ' ', $text);
    $text = str_replace ('<br>', ' ', $text);
    $text = wordwrap ($text, $wordlength, ' ', true);
    $text = preg_replace ("/[ ]+/", ' ', $text);
    $text_length = strlen ($text);
    $text_array = explode (" ", $text);

    $newtext = '';
    for ($array_key = 0, $length = 0; $length <= $text_length; $array_key++) {
      $length = strlen ($newtext) + strlen ($text_array[$array_key]) + 1;
      if ($length > $maxchar) break;
      $newtext = $newtext . ' ' . $text_array[$array_key];
    }

    return $newtext;
  } // function tep_limit_text


  function tep_array_values_to_string($array, $separator = ',') {
    $get_string = '';
    if (sizeof($array) > 0) {
       while (list($key, $value) = each($array)) {
         $get_string .= $value . $separator;
       }
       $remove_chars = strlen($separator);
       $get_string = substr($get_string, 0, -$remove_chars);
    }
    return $get_string;
  }
?>
