<?php
/*
  $Id: cm_i_featured_products.php

  Featured Products CE Phoenix v2.0.0
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019: Rainer Schmied - @raiwa

  All rights reserved.﻿﻿

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class cm_i_featured_products {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;
    var $delete_tables = false;
    var $version = 'Phoenix_v2.0.0';

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_TITLE;
      $this->description = MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DESCRIPTION;
      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';

      if ( defined('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_STATUS == 'True');
        $this->delete_tables = (MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DELETE_TABLES == 'True');
      }
    }

    function execute() {
      global $oscTemplate, $PHP_SELF, $languages_id, $currencies, $new_products_category_id, $category;

      // include the tep_recently_limit_text function
      require_once('includes/functions/featured.php');

      $content_width = (int)MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_CONTENT_WIDTH;
      $featured_products_content = NULL;

      $featured_products_category_id =  (isset($new_products_category_id))?$new_products_category_id:'0';
      $cat_name = $category['categories_name'];

      list($usec, $sec) = explode(' ', microtime());
      srand( (float) $sec + ((float) $usec * 100000) );
      $mtm= rand();

      if ( (!isset($featured_products_category_id)) || ($featured_products_category_id == '0') ) {
        // Phocea Optimize featured query
        // Ben: Option to only show featured_products on sale
        $query = 'SELECT p.products_id, p.products_image, p.products_tax_class_id, IF (s.status, s.specials_new_products_price, NULL) AS specials_new_products_price, p.products_price, p.products_quantity as in_stock, if(s.status, 1, 0) as is_special, pd.products_name ';

        if ( defined('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_DESCRIPTION') && MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_DESCRIPTION == 'True' ) {
          $query .= ', pd.products_description ';
        }

        if ( defined('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SPECIALS_ONLY') && MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SPECIALS_ONLY == 'True' ) {
          $query .= 'FROM specials s LEFT JOIN products p ON s.products_id = p.products_id ';
        } else {
          $query .= 'FROM products p LEFT JOIN specials s ON p.products_id = s.products_id ';
        }

        $query .= "LEFT JOIN products_description pd ON p.products_id = pd.products_id AND pd.language_id = '" . $languages_id . "'
                   LEFT JOIN featured f ON p.products_id = f.products_id
                   WHERE p.products_status = '1' AND f.status = '1' order by rand($mtm) DESC limit " . MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_CONTENT_LIMIT;

        $featured_products_query = tep_db_query( $query );
      } else {
        $subcategories_array = array();
        tep_get_subcategories($subcategories_array, $featured_products_category_id);
        $featured_products_category_id_list = tep_array_values_to_string($subcategories_array);
        if ($featured_products_category_id_list == '') {
          $featured_products_category_id_list .= $featured_products_category_id;
        } else {
          $featured_products_category_id_list .= ',' . $featured_products_category_id;
        }

        if ( defined('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SUB_CATEGORIES') && MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SUB_CATEGORIES == 'True' ) {
          // current catID as starting value
          $cats[] = $new_products_category_id;
          // put cat-IDs of all cats nested in current branch into $cats array,
          // go through all subbranches
          for($i=0; $i<count($cats); $i++) {
          $categorie_query = tep_db_query("SELECT categories_id FROM categories WHERE parent_id = '" . (int)$cats[$i] . "'");
          while ($categorie = tep_db_fetch_array($categorie_query)) {
            $cats[] = $categorie['categories_id'];
          }
          // sort out doubles
          $cats = array_unique($cats);
          }
          $catIdSql = implode(', ', $cats);
        } else {
          $catIdSql = $featured_products_category_id_list;
        }

        // Phocea Optimize featured query
        $query = 'SELECT distinct p.products_id, p.products_image, p.products_tax_class_id, IF (s.status, s.specials_new_products_price, NULL) AS specials_new_products_price, p.products_price, p.products_quantity as in_stock, if(s.status, 1, 0) as is_special, pd.products_name ' . ( defined('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_DESCRIPTION') && MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_DESCRIPTION == 'True' ? ', pd.products_description ' : '') . '
        FROM products p LEFT JOIN products_to_categories p2c using(products_id)
        LEFT JOIN categories c USING (categories_id)
        LEFT JOIN featured f ON p.products_id = f.products_id
        LEFT JOIN specials s ON p.products_id = s.products_id
        LEFT JOIN products_description' . " pd ON p.products_id = pd.products_id AND pd.language_id = '" . $languages_id . "'
        where c.categories_id IN(" . $catIdSql . ") AND p.products_status = '1' AND f.status = '1' ";

        if ( defined('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SPECIALS_ONLY') && MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SPECIALS_ONLY == 'true' ) {
          $query .= " AND s.status = '1' ";
        }
        $query .= 'ORDER BY rand(' . $mtm . ') DESC LIMIT ' . MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_CONTENT_LIMIT;

        $featured_products_query = tep_db_query( $query );
      }

      $num_featured_products = tep_db_num_rows($featured_products_query);

      if ($num_featured_products > 0) { // Show only if we still have products in the array

        ob_start();
        include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
        $template = ob_get_clean();

        $oscTemplate->addContent($template, $this->group);

      } //if (count ($featured_products_query)
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Current Version', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_VERSION_INSTALLED', '" . $this->version . "', '', '6', '0',   'tep_version_readonly(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Featured Products Module', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_STATUS', 'True', 'Should the featured_products block be shown on the index page?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_CONTENT_WIDTH', '12', 'What width container should the content be shown in?', '6', '2', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SORT_ORDER', '1100', 'Sort order of display. Lowest is displayed first.', '6', '3', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Number of Products', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_CONTENT_LIMIT', '6', 'How many featured products should be shown?', '6', '4', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Include Sub Categories When Displaying Featured Products', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SUB_CATEGORIES', 'True', 'Set to true or false in order to display featured products including sub categories.', '6', '5', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Maximum word length', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_WORD_LENGTH', '40', 'Maximum number of characters in a single word (Needed to prevent breaking box width)', '6', '6', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Show the product description', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_DESCRIPTION', 'False', 'Show the product description in the Featured Products module?', '6', '7', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Maximum description length', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DESCRIPTION_LENGTH', '250', 'The number of characters (to the nearest word) of the description to display in the Featured Products module', '6', '8', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Specials Only When Displaying Featured Products', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SPECIALS_ONLY', 'False', 'Set to true or false in order to display only on specials featured products.', '6', '9', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Show the product MORE button', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_BUTTON', 'True', 'Show the MORE button in the Featured Products module?', '6', '10', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Display Button', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_BUTTON', 'View', 'Which button should display (View, Buy).', '6', '1', 'tep_cfg_select_option(array(\'View\', \'Buy\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Products In Each Row (SM)', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_SM', '2', 'How many products should display per Row in SM (Small) viewport?', '6', '4', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Products In Each Row (MD)', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_MD', '3', 'How many products should display per Row in MD (Medium) viewport?', '6', '4', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Products In Each Row (LG)', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_LG', '4', 'How many products should display per Row in LG (Large) viewport?', '6', '4', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Products In Each Row (XL)', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_XL', '6', 'How many products should display per Row in XL (Extra Large) viewport?', '6', '4', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");

      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Delete auto created tables on module Remove', 'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DELETE_TABLES', 'False', 'Do you want to remove the tables that where created during installing this module?<br><i>Note: all the created data will be deleted</i>.', '6', '13', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

      // CREATE NEEDED TABLE INTO DB
      tep_db_query("
         CREATE TABLE IF NOT EXISTS `featured` (
        `featured_id` int(11) NOT NULL auto_increment,
        `products_id` int(11) NOT NULL default '0',
        `featured_date_added` datetime default NULL,
        `featured_last_modified` datetime default NULL,
        `expires_date` datetime default NULL,
        `date_status_change` datetime default NULL,
        `status` int(1) default '1',
        PRIMARY KEY  (`featured_id`),
        KEY `idx_products_id` (`products_id`)
         ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;
     ");
  }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      // DELETE TABLE IF SET TO TRUE
      if($this->delete_tables){
        tep_db_query("DROP TABLE IF EXISTS `featured`");
      }
    }

    function keys() {
      return array('MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_VERSION_INSTALLED',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_STATUS',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_CONTENT_WIDTH',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SORT_ORDER',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_CONTENT_LIMIT',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SUB_CATEGORIES',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_WORD_LENGTH',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_DESCRIPTION',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SPECIALS_ONLY',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_SHOW_BUTTON',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DESCRIPTION_LENGTH',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_BUTTON',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_SM',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_MD',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_LG',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DISPLAY_ROW_XL',
           'MODULE_CONTENT_INDEX_FEATURED_PRODUCTS_DELETE_TABLES');
    }
  } // end class

// function show the version read only
  if(!function_exists('tep_version_readonly')) {
    function tep_version_readonly($value){
      $version_text = '<br>Version ' . $value;
      return $version_text;
    }
  }
